#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define INF 9999

/* Structure de graphe et fonctions */
typedef struct triplet{
   int i;
   int j;
   int poids;
} triplet;

triplet * new_triplet(int i,int j, int poids){
    triplet *t=malloc(sizeof(*t));
    t->i = i;
    t->j= j;
    t->poids = poids;
    return t;
}

typedef struct graphe {
   int nbs; /* nombre de sommets*/
   int nba; /* nombre d aretes*/
   triplet * aretes; /* vecteur d aretes*/
} graphe;

/* Fonctions de la structure graphe */


/* Algorithme de Dijkstra, avec l'implémentation triplets */


/* Algorithme de Bellman-Ford, avec l'implémentation triplets. */

int main(){
    graphe *grph=remplir_graphe(12);
    print_aretes(grph);
    printf("\n \n");
    printf("Affichage du résultat avec Dijkstra : \n");
    dijkstra_triplet(grph,0);
    printf("\n \n");
    printf("Affichage du résultat avec Bellman-Ford : \n");
    bellmanford(grph,0);
    delete_graphe(grph);
    return 0;
/*
    int n=10;
    clock_t td, ta;
    while (n<41){
        graphe *grph=remplir_graphe(n);
        // Test Dijkstra
        td = clock();
        for (int i=0;i<n;i++)
        {
            dijkstra_triplet(grph,i);
        }
        ta=clock();
        printf ("Dijkstra : %d \t \t",(int) (ta-td));
        // Test Bellman-Ford
        td = clock();
        for (int i=0;i<n;i++)
        {
            bellmanford(grph,i);
        }
        ta=clock();
        printf ("Bellman-Ford : %d \n",(int) (ta-td));
        n+=5;
    }
*/
}